/*
 You Control Desktops Keygen
 This code will create a valid license file to use with You Control Desktops.
 Grabs en0 interface mac address (code ripped from Mac OS X ifconfig),
 generates the needed digests, creates the licence file, encrypts it and base64
 encodes it.
 
 There is one licence file, and one plist file with a signature.
 
 This code is for educational/learning purposes. Do not use it for piracy :)
 I'm not responsable whatsoever by any utilization of this code.
 
 It's a bit big and unorganized... I'm not a l33t C coder! Sorry...
 But at least it's a good example about openssl API usage!
 
 (c) fG! 2008
 
 Compile with gcc -o keygen keygen.c -lcrypto
 
 v1.1 - Lame bug because BIO_get_mem_data doesn't nul terminates :]
 
*/

/* standard stuff */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <getopt.h>
/* openssl includes */
#include <openssl/evp.h>
#include <openssl/rsa.h>
#include <openssl/err.h>

#define VERSION "1.1"
#define INTERFACE "en0"

void usage (void);
void getmac (void);

char 	macaddress[18];

void usage()
{
	printf(
	"You Control Desktops v1.2 Keygen v%s (c) fG! 2008\n\n"
	"usage: keygen [--debug] --private=<privatekey> [--public=<publickey>]\n\n"
	"Where:\n"
	"<privatekey> : full path to private key file\n"
	"<publickey>  : full path to public key file (if debug is turned on)\n"
	"debug        : to enable debug messages and tests (public key required)\n\n", VERSION
	);
	exit(1);
}

main(int argc, char *argv[])
{

 int debug = 0;
 EVP_MD_CTX signctx, tempctx, pluginctx, temppluginctx;
 BIO *bio_mem, *bio64, *bio_out;
 FILE *pkey_in, *licencefile, *pluginfile;
 EVP_PKEY *pkey;
 int i, err;
 unsigned int sig_len, temp_len, pluginsig_len;
 char expirationdate[] = "2100-12-31";
 // change the last numbers if you want...
 char serialnumber[] = "YCA-100-0001-EDXK9HXD";
 char name[256], *pname;
 char *privatekeylocation, *publickeylocation;
 unsigned char temp_value[EVP_MAX_MD_SIZE];
// info for the license digest
 static char licenseversion[] = "1";
 static char productversion[] = "1";
 static char productname[] = "You Control";
// info for the plugin digest
 static char signme[] = "YSMultiDesktopModule 0";

// required structure for long options
 static struct option long_options[]={
	{ "private", required_argument, NULL, 'p' },
	{ "public", required_argument, NULL, 'u' },
	{ "debug", no_argument, NULL, 'd' },
	{ NULL, 0, NULL, 0 }
 };
 int option_index = 0, c;

 // process command line options
 while ((c = getopt_long (argc, argv, "dp:u:", long_options, &option_index)) != -1)
 {
	switch (c)
	{
		case ':':
		 usage();
		 break;
		case '?':
		 usage();
		 break;
		case 'd':
		 debug = 1;
		 break;		case 'p':		 privatekeylocation = optarg;		 break;
		case 'u':
		 publickeylocation = optarg;
		 break;		default:
		 usage();	}
 }

 // check arguments
 if(argc<2)
 	usage();

 if(debug && publickeylocation == NULL)
 {
  	fprintf(stderr,"ERROR: Debug requires public key parameter!\n\n");
  	usage();
 }

 // load the error strings
 ERR_load_crypto_strings();
 
 // Open the private key
 if ( (pkey_in = fopen(privatekeylocation, "r")) == NULL)
 {
  fprintf(stderr, "\nERROR: Error while opening private key file %s\n\n", privatekeylocation);
  exit(1);
 }
 // load private key
 pkey = PEM_read_PrivateKey(pkey_in, NULL, NULL, NULL);
 if (pkey == NULL)
 {
 	printf("ERROR: ");
	ERR_print_errors_fp (stderr);
	exit (1);
 }
 fclose(pkey_in);

// Get input data
 printf("Insert name:\n");
 fflush(stdout);
 fgets(name, 256, stdin);

 // retrieve mac address
 getmac();
 if(debug) printf("Mac address is: %s\n", macaddress);

 // initialize a signature for licence file, with SHA1
 // SignUpdate function is what we look for, since this function uses the DigestUpdate functions to hash data
 EVP_SignInit(&signctx,EVP_sha1());
 // hash required data into signature context
 EVP_SignUpdate(&signctx, expirationdate, strlen(expirationdate));
 EVP_SignUpdate(&signctx, licenseversion, strlen(licenseversion));
 EVP_SignUpdate(&signctx, macaddress, strlen(macaddress));
 EVP_SignUpdate(&signctx, name, strlen(name));
 EVP_SignUpdate(&signctx, productname, strlen(productname));
 EVP_SignUpdate(&signctx, productversion, strlen(productversion));
 EVP_SignUpdate(&signctx, serialnumber, strlen(serialnumber));

// initialize signature for plugin
 EVP_SignInit(&pluginctx,EVP_sha1());
// hash required data
 EVP_SignUpdate(&pluginctx, signme, strlen(signme));
 
 // this code will show the computed digest for licence file
 if (debug)
 {
	// create a copy of the ctx so we can create a digest to display ! we must always initialize temp ctx
	 EVP_MD_CTX_init(&tempctx); 
	// copy from signctx to tempctx
 	EVP_MD_CTX_copy_ex(&tempctx, &signctx); 
	// finalize the digest
 	EVP_DigestFinal_ex(&tempctx, temp_value, &temp_len);
 	EVP_MD_CTX_cleanup(&tempctx);
 	printf("Digested %d bytes\n",temp_len);
 	printf("Licence Digest is: ");
 	for(i = 0; i < temp_len; i++) printf("%02x", temp_value[i]);
 	printf("\n");
 }
 
 int pkeysize; 
 pkeysize = EVP_PKEY_size(pkey);
 unsigned char result[pkeysize];
 unsigned char pluginresult[pkeysize];

 if (debug) printf("Key size is:%d\n",pkeysize);

 // sign hashed data with private key and put the result into buffer
 err = EVP_SignFinal(&signctx, result, &sig_len, pkey);
 if (err != 1) 
 {
 	ERR_print_errors_fp(stderr);
 	exit (1);
 }

 if (debug)
 {
	// print signature in hex 
 	printf("Generating...\nLicence file Signature in hex is:\n");
 	for(i = 0; i < sig_len; i++) printf("%02x", result[i]);
 	printf("\nEnd of licence file signature\n");
 }
 
 // sign plugin hashed data
 err = EVP_SignFinal(&pluginctx, pluginresult, &pluginsig_len, pkey);
 if (err != 1)
 {
 	ERR_print_errors_fp(stderr);
 	exit (1);
 }
 // clean private key
 EVP_PKEY_free (pkey);

 if (debug)
 {
	// print signature in hex 
 	printf("Generating...\nPlugin Signature in hex is:\n");
 	for(i = 0; i < pluginsig_len; i++) printf("%02x", pluginresult[i]);
 	printf("\nEnd of plugin signature\n");
 }
 
 if (debug)
 { 
	/* Read public key */
 	if ( (pkey_in = fopen(publickeylocation, "r")) == NULL)
 	{
  		fprintf(stderr, "\nERROR: Error while opening public key file %s\n\n", publickeylocation);
  		exit(1);
 	}
	// load public key
 	pkey = PEM_read_PUBKEY(pkey_in, NULL, NULL, NULL);
 	if (pkey == NULL)
 	{
 		printf("ERROR: ");
  		ERR_print_errors_fp (stderr);
  		exit (1);
 	}
 	fclose(pkey_in);
 }
 
 if (debug)
 {
	// check if our generated licence signature is valid, 1 is OK, 0 failure 
 	err = EVP_VerifyFinal(&signctx, result, sig_len, pkey);
 	printf("Testing licence signature...\nLicence Signature Status is: %d\n", err);
	// check if our generated plugin signature is valid, 1 is OK, 0 failure 
 	err = EVP_VerifyFinal(&pluginctx, pluginresult, pluginsig_len, pkey);
 	printf("Testing plugin signature...\nPlugin Signature Status is: %d\n", err);
 }

// clean context to avoid memory leaks
 EVP_MD_CTX_cleanup(&signctx);
 EVP_MD_CTX_cleanup(&pluginctx);

 /*
   generate licence base64 encoded signature
 */
 
 if (debug) printf("Generating licence file...\n");
 // bio for output
 // this one will output to stdout
 // bio_mem = BIO_new_fp(stdout,BIO_NOCLOSE);
 // we want a mem BIO to hold the buffer
 bio_mem = BIO_new(BIO_s_mem());
 // base64 filter
 bio64 = BIO_new(BIO_f_base64());
 // create chain
 bio_out = BIO_push(bio64, bio_mem);
 // write
 BIO_write(bio_out, result, sizeof(result));
 // flush buffers, very important !
 BIO_flush(bio_out);

 /* long BIO_get_mem_data(BIO *b, char **pp)
   BIO_get_mem_data() sets pp to a pointer to the start of the memory BIOs
   data and returns the total amount of data available. It is implemented
   as a macro.
   
 IMPORTANT: BIO_get_mem_data DOESNT nul terminate!!!!

 */
 char *signaturebuffer;
 int getmemlength=0;
 getmemlength = BIO_get_mem_data(bio_mem, &signaturebuffer);
 // nul terminate the buffer :)
 signaturebuffer[getmemlength] = '\0';
  
 char licenceoutput[4096];  
 // send the output to a buffer so we can encrypt it 
 snprintf(licenceoutput,sizeof(licenceoutput),
 "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
 "<!DOCTYPE plist PUBLIC \"-//Apple Computer//DTD PLIST 1.0//EN\" \"http://www.apple.com/DTDs/PropertyList-1.0.dtd\">\n"
 "<plist version=\"1.0\">\n"
 "<dict>\n"
 "<key>emailAddress</key>\n"
 "<string></string>\n"
 "<key>expirationDate</key>\n"
 "<date>%sT00:00:00Z</date>\n"
 "<key>licenseVersion</key>\n"
 "<integer>1</integer>\n"
 "<key>mac</key>\n"
 "<string>%s</string>\n"
 "<key>modules</key>\n"
 "<array>\n"
 "</array>\n"
 "<key>name</key>\n"
 "<string>%s</string>\n"
 "<key>productName</key>\n"
 "<string>You Control</string>\n"
 "<key>productVersion</key>\n"
 "<integer>1</integer>\n"
 "<key>serialNumber</key>\n"
 "<string>%s</string>\n"
 "<key>licenseSum</key>\n"
 "<data>%s"
 "</data>\n"
 "</dict>\n"
 "</plist>\n\0",
 expirationdate,macaddress,name,serialnumber,signaturebuffer);
 // free BIO
 BIO_free_all(bio_mem);

 // create licence file name
 // format is 00-00-00-00-00-00.You Control Desktops.1.licenseKey
 // where 00-00 ... is mac address
 int x=0;
 
 while (macaddress[x++] != '\0')
 {
 	if (macaddress[x] == ':')
 		macaddress[x] = '-';
 }	
 
 char licencefilename[60];
 snprintf(licencefilename,sizeof(licencefilename), "%s.You Control.1.licenseKey\0", macaddress);
 
 // create the licence file
 if ( (licencefile = fopen(licencefilename, "wb")) == NULL)
 {
 	fprintf(stderr, "\nERROR: Error while opening licence file %s\n\n", licencefilename);
 	exit(1);
 }
 
// encrypt the file
// we must have a BIO_mem with the unencrypted licence file
// and a BIO_new_fp to write the encrypted output to our stream
// we can copy our unencrypted licence file using BIO_new_mem_buf function
 BIO *bio_in, *biocipher;
 unsigned char *key="You Software";
 unsigned char *iv=0;
 char outputbuffer[2048];
 char inputbuffer[256];
 int size;
 
 // create a BIO read only mem buffer
 bio_in = BIO_new_mem_buf(licenceoutput, -1);
 // BIO to write encrypted file
// bio_out = BIO_new_file(licencefilename, "w");
 bio_out = BIO_new_fp(licencefile, BIO_NOCLOSE);
 // base64 and cipher filters
 bio64 = BIO_new(BIO_f_base64());
 biocipher = BIO_new(BIO_f_cipher());
 // 1 to encrypt, 0 to decrypt
 BIO_set_cipher(biocipher,EVP_bf_cbc(), key, NULL, 1);
 // set the bio chain <- remember write transverses the chain backwards
 bio_out = BIO_push(bio64,bio_out);
 bio_out = BIO_push(biocipher,bio_out);
 while((size = BIO_read(bio_in,inputbuffer, sizeof(inputbuffer))) > 0) 
 {
  BIO_write(bio_out, inputbuffer, size);
 }
 // flush the bio to make sure everything is written!!
 BIO_flush(bio_out);
 BIO_free_all(bio_in);
 BIO_free_all(bio_out);

 /*
   generate plugin base64 encoded signature
 */
 if (debug) printf("Generating plugin file...\n");
 // bio for output
 // bio_mem = BIO_new_fp(stdout,BIO_NOCLOSE);
 bio_mem = BIO_new(BIO_s_mem());
 // base64 filter
 bio64 = BIO_new(BIO_f_base64());
 // create chain
 bio_out = BIO_push(bio64, bio_mem);
 // write
 BIO_write(bio_out, pluginresult, sizeof(pluginresult));
 // flush buffers, very important !
 BIO_flush(bio_out);

 char *pluginbuffer;
 getmemlength = BIO_get_mem_data(bio_mem,&pluginbuffer);
 // nul terminate the buffer :)
 pluginbuffer[getmemlength] = '\0';

 char pluginoutput[4096]; 
 snprintf(pluginoutput,sizeof(pluginoutput),
 "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
 "<!DOCTYPE plist PUBLIC \"-//Apple Computer//DTD PLIST 1.0//EN\" \"http://www.apple.com/DTDs/PropertyList-1.0.dtd\">\n"
 "<plist version=\"1.0\">\n"
 "<dict>\n"
 "<key>YSModuleClass</key>\n"
 "<string>YSMultiDesktopModule</string>\n"
 "<key>YSModuleSettingsClass</key>\n"
 "<string>YSMultiDesktopModuleSettings</string>\n"
 "<key>YSModuleDescription</key>\n"
 "<string>MultiDesktopModule.rtf</string>\n"
 "<key>YSModuleIcon</key>\n"
 "<string>MultiDesktopModule16.tif</string>\n"
 "<key>YSModuleIconLarge</key>\n"
 "<string>MultiDesktopModule32.tif</string>\n"
 "<key>YSModuleRunMode</key>\n"
 "<integer>0</integer>\n"
 "<key>YSModuleSignature</key>\n"
 "<data>\n"
 "%s"
 "</data>\n"
 "<key>YSModuleTitle</key>\n"
 "<string>Desktops</string>\n"
 "<key>YSModuleVersion</key>\n"
 "<string>1.2</string>\n"
 "<key>YSModuleMinSystemVersion</key>\n"
 "<string>10.3</string>\n"
 "<key>YSModuleInjectCocoa</key>\n"
 "<dict>\n"
 "<key>YSModuleInjectPluginName</key>\n"
 "<string>YSMDHelper</string>\n"
 "</dict>\n"
 "<key>YSModuleInjectCarbon</key>\n"
 "<dict>\n"
 "<key>YSModuleInjectPluginName</key>\n"
 "<string>YSMDHelperCarbon</string>\n"
 "</dict>\n"
 "<key>YSModuleCanOwnMenu</key>\n"
 "<true/>\n"
 "</dict>\n"
 "</plist>\n\0",
 pluginbuffer);

 // create the plugin file
 if ( (pluginfile = fopen("MultiDesktopModule.plist", "wb")) == NULL)
 {
 	fprintf(stderr, "\nERROR: Error while opening plugin file %s\n\n", licencefilename);
 	exit(1);
 }
 // write to file
 fprintf(pluginfile, "%s", pluginoutput);

 // and voila, the end !
 printf("\nAll done !\n\n"
 "You will need to copy %s file to homedir/Library/Application Support/You Software/Licenses/\n"
 "And MultiDesktopModule.plist to You Control Desktops.app/Contents/PlugIns/MultiDesktopModule.plugin/Contents/Resources/\n"
 "\nDon't forget to patch the program :)\n",
 licencefilename);
 
}

/*
 Retrieve Mac Address code
 This should have been in a separate source file ;) 
 Ripped from Apple ifconfig source... Oh yeah!
*/

#include <sys/param.h>
#define KERNEL_PRIVATE
#include <sys/ioctl.h>
#undef KERNEL_PRIVATE
#include <sys/socket.h>
#include <sys/sysctl.h>
#include <sys/time.h>

#include <net/ethernet.h>
#include <net/if.h>
#include <net/if_var.h>
#include <net/if_dl.h>
#include <net/if_types.h>
#include <net/route.h>

/* IP */
#include <netinet/in.h>
//#include <netinet/in_var.h>
//#include <arpa/inet.h>
//#include <netdb.h>

#include <ctype.h>
#include <err.h>
#include <errno.h>
#include <fcntl.h>
//#include <stdio.h>
//#include <stdlib.h>
//#include <string.h>
//#include <unistd.h>

struct	ifreq		ifr, ridreq;
struct	ifaliasreq	addreq;
struct	sockaddr_in	netmask;

char	name[16];

int	flags;
int	metric;
int	mtu;
int	setaddr;
int	setipdst;
int	setmask;
int	doalias;
int	clearaddr;
int	newaddr = 1;

struct	afswtch;

void	status __P((const struct afswtch *afp, int addrcount,
		    struct sockaddr_dl *sdl, struct if_msghdr *ifm,
		    struct ifa_msghdr *ifam));

typedef	void af_status __P((int, struct rt_addrinfo *));
typedef	void af_getaddr __P((const char *, int));
typedef void af_getprefix __P((const char *, int));

af_status	ether_status;
af_getaddr	ether_getaddr;

/* Known address families */
const
struct	afswtch {
	const char *af_name;
	short af_af;
	af_status *af_status;
	af_getaddr *af_getaddr;
	af_getprefix *af_getprefix;
	u_long af_difaddr;
	u_long af_aifaddr;
	caddr_t af_ridreq;
	caddr_t af_addreq;
} afs[] = {
#define C(x) ((caddr_t) &x)
	{ "ether", AF_LINK, ether_status, ether_getaddr, NULL,
	     0, SIOCSIFLLADDR, NULL, C(ridreq) },
	{ 0,	0,	    0,		0 }
};

#define RIDADDR 0
#define ADDR	1
#define NMASK	2
#define DSTADDR	3

void getmac()
{
	int foundit = 0;
	const struct afswtch *afp = 0;
	int addrcount;
	struct	if_msghdr *ifm, *nextifm;
	struct	ifa_msghdr *ifam;
	struct	sockaddr_dl *sdl;
	char	*buf, *lim, *next;

	size_t needed;
	int mib[6];

// interface name we want to retrieve mac address
	strcpy(name, INTERFACE);

	mib[0] = CTL_NET;
	mib[1] = PF_ROUTE;
	mib[2] = 0;
	mib[3] = 2;	/* AF_INET address family */
	mib[4] = NET_RT_IFLIST;
	mib[5] = 0;

	if (sysctl(mib, 6, NULL, &needed, NULL, 0) < 0)
		errx(1, "iflist-sysctl-estimate");
	if ((buf = malloc(needed)) == NULL)
		errx(1, "malloc");
	if (sysctl(mib, 6, buf, &needed, NULL, 0) < 0)
		errx(1, "actual retrieval of interface table");
	lim = buf + needed;

	next = buf;
	while (next < lim) {
		ifm = (struct if_msghdr *)next;
				
		if (ifm->ifm_type == RTM_IFINFO) {
			sdl = (struct sockaddr_dl *)(ifm + 1);
			flags = ifm->ifm_flags;
		} else {
			fprintf(stderr, "out of sync parsing NET_RT_IFLIST\n");
			fprintf(stderr, "expected %d, got %d\n", RTM_IFINFO, ifm->ifm_type);
			fprintf(stderr, "msglen = %d\n", ifm->ifm_msglen);
			fprintf(stderr, "buf:%p, next:%p, lim:%p\n", buf, next, lim);
			exit (1);
		}

		next += ifm->ifm_msglen;
		ifam = NULL;
		addrcount = 0;
		while (next < lim) {
			nextifm = (struct if_msghdr *)next;

			if (nextifm->ifm_type != RTM_NEWADDR)
				break;

			if (ifam == NULL)
				ifam = (struct ifa_msghdr *)nextifm;

			addrcount++;
			next += nextifm->ifm_msglen;
		}
		if (strlen(name) != sdl->sdl_nlen)
			continue; 

// check if it's our specific interface, if yes then get status, else keep searching
		if (strncmp(name, sdl->sdl_data, sdl->sdl_nlen) != 0)
			continue; 

		status(afp, addrcount, sdl, ifm, ifam);
		foundit++;
		break;
	}
	free(buf);
	if (foundit == 0)
		errx(1, "interface %s does not exist", name);
}


/*
 * Retrieve the status of the interface.
 */
void
status(afp, addrcount, sdl, ifm, ifam)
	const struct afswtch *afp;
	int addrcount;
	struct	sockaddr_dl *sdl;
	struct if_msghdr *ifm;
	struct ifa_msghdr *ifam;
{
	int allfamilies, s;
	
	if (afp == NULL)
	{
		allfamilies = 1;
		afp = &afs[0];
	} else
		allfamilies = 0;

	ifr.ifr_addr.sa_family = AF_INET;

	strncpy(ifr.ifr_name, name, sizeof ifr.ifr_name);

	if ((s = socket(ifr.ifr_addr.sa_family, SOCK_DGRAM, 0)) < 0)
		err(1, "socket");

	if (allfamilies || afp->af_status == ether_status)
		ether_status(s, (struct rt_addrinfo *)sdl);
		
	close(s);
	return;
}

void
ether_status(s, info)
	int s ;
	struct rt_addrinfo *info;
{
	char *cp, *tempptr;		
	int n;
	struct sockaddr_dl *sdl = (struct sockaddr_dl *)info;

	// temporary pointer to the array
	tempptr=macaddress;
	cp = (char *)LLADDR(sdl);
			
	if ((n = sdl->sdl_alen) > 0)
	{
      	while (--n >= 0)
      	{
		    snprintf(tempptr,4,"%02x%c",*cp++ & 0xff, n>0? ':' : '\0');
			// move to next position
		    tempptr +=3;
		}
	}
}

void  
ether_getaddr(addr, which)
        const char *addr;
        int which;
{
        struct ether_addr *ea;
        struct sockaddr *sea = &ridreq.ifr_addr;

        ea = ether_aton(addr);
        if (ea == NULL)
                errx(1, "malformed ether address");
        if (which == NMASK)
                errx(1, "Ethernet does not use netmasks");
        sea->sa_family = AF_LINK;
        sea->sa_len = ETHER_ADDR_LEN;      
        bcopy(ea, sea->sa_data, ETHER_ADDR_LEN);
}
